## coccinelle 1.1.0.deb

=== parsing_cocci/Makefile ===
LIBRARY=parsing_cocci

include ../Makefile.library

=== setup/Makefile ===
# Makefile.in generated by automake 1.15.1 from Makefile.am.
# setup/Makefile.  Generated from Makefile.in by configure.

# Copyright (C) 1994-2017 Free Software Foundation, Inc.

# This Makefile.in is free software; the Free Software Foundation
# gives unlimited permission to copy and/or distribute it,
# with or without modifications, as long as this notice is preserved.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY, to the extent permitted by law; without
# even the implied warranty of MERCHANTABILITY or FITNESS FOR A
# PARTICULAR PURPOSE.



# This is a makefile that is not used by this project,
# except for one purpose only:
#
# to all automake -ac in the root directory to (re)generate
# the files install-sh and missing in the setup subdirectory.
#
# The following files (with respect to the top directory)
# have been included in order not to have a dependency on
# automake:
#
# * setup/{Makefile.am, Makefile.in, install-sh, missing}
# * configure
# * Makefile.am
#
# Note: Makefile.in in the top directory is not generated
# from Makefile.am in the top directory! That Makefile.in
# is the official source file, and that Makefile.am is a
# placeholder to fool automake (which we do not really use).

am__is_gnu_make = { \
  if test -z '$(MAKELEVEL)'; then \
    false; \
  elif test -n '$(MAKE_HOST)'; then \
    true; \
  elif test -n '$(MAKE_VERSION)' && test -n '$(CURDIR)'; then \
    true; \
  else \
    false; \
  fi; \
}
am__make_running_with_option = \
  case $${target_option-} in \
      ?) ;; \
      *) echo "am__make_running_with_option: internal error: invalid" \
              "target option '$${target_option-}' specified" >&2; \
         exit 1;; \
  esac; \
  has_opt=no; \
  sane_makeflags=$$MAKEFLAGS; \
  if $(am__is_gnu_make); then \
    sane_makeflags=$$MFLAGS; \
  else \
    case $$MAKEFLAGS in \
      *\\[\ \	]*) \
        bs=\\; \
        sane_makeflags=`printf '%s\n' "$$MAKEFLAGS" \
          | sed "s/$$bs$$bs[$$bs $$bs	]*//g"`;; \
    esac; \
  fi; \
  skip_next=no; \
  strip_trailopt () \
  { \
    flg=`printf '%s\n' "$$flg" | sed "s/$$1.*$$//"`; \
  }; \
  for flg in $$sane_makeflags; do \
    test $$skip_next = yes && { skip_next=no; continue; }; \
    case $$flg in \
      *=*|--*) continue;; \
        -*I) strip_trailopt 'I'; skip_next=yes;; \
      -*I?*) strip_trailopt 'I';; \
        -*O) strip_trailopt 'O'; skip_next=yes;; \
      -*O?*) strip_trailopt 'O';; \
        -*l) strip_trailopt 'l'; skip_next=yes;; \
      -*l?*) strip_trailopt 'l';; \
      -[dEDm]) skip_next=yes;; \
      -[JT]) skip_next=yes;; \
    esac; \
    case $$flg in \
      *$$target_option*) has_opt=yes; break;; \
    esac; \
  done; \
  test $$has_opt = yes
am__make_dryrun = (target_option=n; $(am__make_running_with_option))
am__make_keepgoing = (target_option=k; $(am__make_running_with_option))
pkgdatadir = $(datadir)/coccinelle
pkgincludedir = $(includedir)/coccinelle
pkglibdir = $(libdir)/coccinelle
pkglibexecdir = $(libexecdir)/coccinelle
am__cd = CDPATH="$${ZSH_VERSION+.}$(PATH_SEPARATOR)" && cd
install_sh_DATA = $(install_sh) -c -m 644
install_sh_PROGRAM = $(install_sh) -c
install_sh_SCRIPT = $(install_sh) -c
INSTALL_HEADER = $(INSTALL_DATA)
transform = $(program_transform_name)
NORMAL_INSTALL = :
PRE_INSTALL = :
POST_INSTALL = :
NORMAL_UNINSTALL = :
PRE_UNINSTALL = :
POST_UNINSTALL = :
subdir = setup
ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
am__aclocal_m4_deps = $(top_srcdir)/setup/cocci.m4 \
	$(top_srcdir)/setup/ocaml.m4 $(top_srcdir)/setup/pkg.m4 \
	$(top_srcdir)/configure.ac
am__configure_deps = $(am__aclocal_m4_deps) $(CONFIGURE_DEPENDENCIES) \
	$(ACLOCAL_M4)
DIST_COMMON = $(srcdir)/Makefile.am $(am__DIST_COMMON)
mkinstalldirs = $(install_sh) -d
CONFIG_CLEAN_FILES =
CONFIG_CLEAN_VPATH_FILES =
AM_V_P = $(am__v_P_$(V))
am__v_P_ = $(am__v_P_$(AM_DEFAULT_VERBOSITY))
am__v_P_0 = false
am__v_P_1 = :
AM_V_GEN = $(am__v_GEN_$(V))
am__v_GEN_ = $(am__v_GEN_$(AM_DEFAULT_VERBOSITY))
am__v_GEN_0 = @echo "  GEN     " $@;
am__v_GEN_1 = 
AM_V_at = $(am__v_at_$(V))
am__v_at_ = $(am__v_at_$(AM_DEFAULT_VERBOSITY))
am__v_at_0 = @
am__v_at_1 = 
SOURCES =
DIST_SOURCES =
am__can_run_installinfo = \
  case $$AM_UPDATE_INFO_DIR in \
    n|no|NO) false;; \
    *) (install-info --version) >/dev/null 2>&1;; \
  esac
am__tagged_files = $(HEADERS) $(SOURCES) $(TAGS_FILES) $(LISP)
am__DIST_COMMON = $(srcdir)/Makefile.in compile install-sh missing
DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
ACLOCAL = ${SHELL} /home/fantasio/work/coccinelle/setup/missing aclocal-1.15
AMTAR = $${TAR-tar}
AM_DEFAULT_VERBOSITY = 1
AUTOCONF = ${SHELL} /home/fantasio/work/coccinelle/setup/missing autoconf
AUTOHEADER = ${SHELL} /home/fantasio/work/coccinelle/setup/missing autoheader
AUTOMAKE = ${SHELL} /home/fantasio/work/coccinelle/setup/missing automake-1.15
AWK = mawk
BASH = /bin/bash
BASH_COMPLETION_CFLAGS = 
BASH_COMPLETION_DIR = /usr/share/bash-completion/completions
BASH_COMPLETION_LIBS = 
CAMLnoreturn_end = 
CAMLnoreturn_start = 
CC = gcc
CCDEPMODE = depmode=none
CFLAGS = -g -O2
COCCI_OCAML_EXTERNAL = /home/fantasio/work/coccinelle/bundles
COCCI_SRCDIR = /home/fantasio/work/coccinelle
COCCI_VERSION = 1.0.8-00205-gd3d29c86
CONFIGURE_FLAGS = 
CONFVERSION = Wed, 24 Feb 2021 14:51:50 +0100
CPP = gcc -E
CPPFLAGS = 
CYGPATH_W = echo
DATE = 
DEFS = -DPACKAGE_NAME=\"coccinelle\" -DPACKAGE_TARNAME=\"coccinelle\" -DPACKAGE_VERSION=\"1.0.8-00205-gd3d29c86\" -DPACKAGE_STRING=\"coccinelle\ 1.0.8-00205-gd3d29c86\" -DPACKAGE_BUGREPORT=\"cocci@systeme.lip6.fr\" -DPACKAGE_URL=\"http://coccinelle.lip6.fr/\" -DPACKAGE=\"coccinelle\" -DVERSION=\"1.0.8-00205-gd3d29c86\"
DEPDIR = .deps
DYNLINK_IS_NATIVE = Dynlink.is_native
ECHO = /bin/echo
ECHO_C = 
ECHO_N = -n
ECHO_T = 
EXEEXT = 
FEATURE_OCAML = 1
FEATURE_PYTHON = 1
FEATURE_bytes = 0
FEATURE_dynlink = 1
FEATURE_menhirLib = 1
FEATURE_parmap = 1
FEATURE_pcre = 1
FEATURE_pyml = 1
FEATURE_stdcompat = 1
FLAGS_bytes = 
FLAGS_dynlink = $(FLAGS_dynlink)
FLAGS_menhirLib = 
FLAGS_parmap = $(FLAGS_parmap)
FLAGS_pcre = $(FLAGS_pcre)
FLAGS_pyml = $(FLAGS_pyml)
FLAGS_stdcompat = $(FLAGS_stdcompat)
GET_TEMP_DIR_NAME_EXPR = (Filename.get_temp_dir_name ())
GIT = /usr/bin/git
GLOBAL_bytes = 
GLOBAL_dynlink = dynlink
GLOBAL_parmap = parmap
GLOBAL_pcre = pcre
GLOBAL_pyml = pyml
GLOBAL_stdcompat = stdcompat
HAVE_PCRE = yes
INSTALL = /usr/bin/install -c
INSTALL_DATA = ${INSTALL} -m 644
INSTALL_PROGRAM = ${INSTALL}
INSTALL_SCRIPT = ${INSTALL}
INSTALL_STRIP_PROGRAM = $(install_sh) -c -s
Int_val = 
Int_val_val = 
LDFLAGS = 
LIBDIR = ${exec_prefix}/lib/coccinelle
LIBOBJS = 
LIBS = 
LOCALLIB_bytes = 0
LOCALLIB_dynlink = 0
LOCALLIB_parmap = 0
LOCALLIB_pcre = 0
LOCALLIB_pyml = 0
LOCALLIB_stdcompat = 0
LTLIBOBJS = 
MAKEINFO = ${SHELL} /home/fantasio/work/coccinelle/setup/missing makeinfo
MAKETARGET_SPATCH = opt-only
MAKE_bytes = 
MAKE_dynlink = 
MAKE_menhirLib = /home/fantasio/work/coccinelle/bundles/menhirLib
MAKE_parmap = 
MAKE_pcre = 
MAKE_pyml = 
MAKE_stdcompat = 
MENHIR = /home/fantasio/work/coccinelle/bundles/menhirLib/menhir
MKDIR_P = /bin/mkdir -p
MODULESOPT_bytes = 
MODULESOPT_dynlink = $(GLOBALOPT_dynlink)
MODULESOPT_menhirLib = 
MODULESOPT_parmap = $(GLOBALOPT_parmap)
MODULESOPT_pcre = $(GLOBALOPT_pcre)
MODULESOPT_pyml = $(GLOBALOPT_pyml)
MODULESOPT_stdcompat = $(GLOBALOPT_stdcompat)
MODULES_bytes = 
MODULES_dynlink = $(GLOBAL_dynlink)
MODULES_menhirLib = 
MODULES_parmap = $(GLOBAL_parmap)
MODULES_pcre = $(GLOBAL_pcre)
MODULES_pyml = $(GLOBAL_pyml)
MODULES_stdcompat = $(GLOBAL_stdcompat)
OBJEXT = o
OCAML = /home/fantasio/.opam/4.09.0/bin/ocaml
OCAMLATLEAST312 = yes
OCAMLATLEAST4020 = yes
OCAMLATLEAST4030 = yes
OCAMLBEST = opt
OCAMLC = /home/fantasio/.opam/4.09.0/bin/ocamlc.opt
OCAMLCDOTOPT = /home/fantasio/.opam/4.09.0/bin/ocamlc.opt
OCAMLCOCCI_FILE = yes_prepare_ocamlcocci.ml
OCAMLCOCCI_MODULE = Yes_prepare_ocamlcocci
OCAMLCORIG = /home/fantasio/.opam/4.09.0/bin/ocamlc.opt
OCAMLDEP = /home/fantasio/.opam/4.09.0/bin/ocamldep
OCAMLDOC = /home/fantasio/.opam/4.09.0/bin/ocamldoc
OCAMLFIND = /home/fantasio/.opam/4.09.0/bin/ocamlfind
OCAMLLEX = /home/fantasio/.opam/4.09.0/bin/ocamllex.opt
OCAMLLEXDOTOPT = /home/fantasio/.opam/4.09.0/bin/ocamllex.opt
OCAMLLIB = /home/fantasio/.opam/4.09.0/lib/ocaml
OCAMLMKLIB = /home/fantasio/.opam/4.09.0/bin/ocamlmklib
OCAMLMKTOP = /home/fantasio/.opam/4.09.0/bin/ocamlmktop
OCAMLOPT = /home/fantasio/.opam/4.09.0/bin/ocamlopt.opt
OCAMLOPTDOTOPT = /home/fantasio/.opam/4.09.0/bin/ocamlopt.opt
OCAMLPROF = /home/fantasio/.opam/4.09.0/bin/ocamlprof
OCAMLVERSION = 4.09.0
OCAMLYACC = /home/fantasio/.opam/4.09.0/bin/ocamlyacc
OCAML_PKG_bigarray = bigarray
OCAML_PKG_bytes = 
OCAML_PKG_dynlink = dynlink
OCAML_PKG_parmap = parmap
OCAML_PKG_pcre = pcre
OCAML_PKG_pyml = pyml
OCAML_PKG_stdcompat = stdcompat
OCAML_PKG_str = str
OCAML_PKG_unix = unix
OPTFLAGS_bytes = 
OPTFLAGS_dynlink = $(OPTFLAGS_dynlink)
OPTFLAGS_menhirLib = 
OPTFLAGS_parmap = $(OPTFLAGS_parmap)
OPTFLAGS_pcre = $(OPTFLAGS_pcre)
OPTFLAGS_pyml = $(OPTFLAGS_pyml)
OPTFLAGS_stdcompat = $(OPTFLAGS_stdcompat)
OPTIMIZED_dynlink = yes
PACKAGE = coccinelle
PACKAGE_BUGREPORT = cocci@systeme.lip6.fr
PACKAGE_NAME = coccinelle
PACKAGE_STRING = coccinelle 1.0.8-00205-gd3d29c86
PACKAGE_TARNAME = coccinelle
PACKAGE_URL = http://coccinelle.lip6.fr/
PACKAGE_VERSION = 1.0.8-00205-gd3d29c86
PATCH = /usr/bin/patch
PATCHELF = 
PATH_SEPARATOR = :
PATH_bigarray = /home/fantasio/.opam/4.09.0/lib/ocaml
PATH_bytes = 
PATH_dynlink = /home/fantasio/.opam/4.09.0/lib/ocaml
PATH_menhirLib = /home/fantasio/work/coccinelle/bundles/menhirLib
PATH_menhirLib_bundle = /home/fantasio/work/coccinelle/bundles/menhirLib
PATH_menhir_bundle = /home/fantasio/work/coccinelle/bundles/menhirLib/menhir
PATH_parmap = /home/fantasio/.opam/4.09.0/lib/parmap
PATH_pcre = /home/fantasio/.opam/4.09.0/lib/pcre
PATH_pyml = /home/fantasio/.opam/4.09.0/lib/pyml
PATH_stdcompat = /home/fantasio/.opam/4.09.0/lib/stdcompat
PATH_str = /home/fantasio/.opam/4.09.0/lib/ocaml
PATH_unix = /home/fantasio/.opam/4.09.0/lib/ocaml
PCRE_CFLAGS = 
PCRE_LIBS = -lpcre
PDFLATEX = /usr/bin/pdflatex
PKG_CONFIG = /home/fantasio/work/coccinelle/setup/fake-subst.sh /usr/bin/pkg-config
PKG_CONFIG_LIBDIR = 
PKG_CONFIG_ORIG = /usr/bin/pkg-config
PKG_CONFIG_PATH = 
PYCOCCI_FILE = yes_pycocci.ml
PYCOCCI_MODULE = Yes_pycocci
PYTHON = python
PYVER = 
REGEXP_FILE = regexp_pcre.ml
REGEXP_MODULE = Regexp_pcre
RUNTIME_OCAMLC_CMD = ocamlc
RUNTIME_OCAMLDEP_CMD = ocamldep
RUNTIME_OCAMLFIND_CMD = ocamlfind
RUNTIME_OCAMLOPT_CMD = ocamlopt
SET_MAKE = 
SHELL = /bin/bash
SPATCHNAME = spatch.opt
STRIP = 
SUBSTITUTED_MENHIR = yes
SUBSTITUTED_OCAMLFIND = 
SUBSTITUTED_OCAMLLEX = 
SUBSTITUTED_OCAMLPROF = 
SUBSTITUTED_OCAMLYACC = 
SUBSTITUTED_PDFLATEX = 
SUBSTITUTED_PKG_CONFIG = 
TAR = /bin/tar
VERSION = 1.0.8-00205-gd3d29c86
Val_Val_int = 
Val_int = 
abs_builddir = /home/fantasio/work/coccinelle/setup
abs_srcdir = /home/fantasio/work/coccinelle/setup
abs_top_builddir = /home/fantasio/work/coccinelle
abs_top_srcdir = /home/fantasio/work/coccinelle
ac_ct_CC = gcc
am__include = include
am__leading_dot = .
am__quote = 
am__tar = $${TAR-tar} chof - "$$tardir"
am__untar = $${TAR-tar} xf -
bindir = ${exec_prefix}/bin
build_alias = 
builddir = .
datadir = ${datarootdir}
datarootdir = ${prefix}/share
docdir = ${datarootdir}/doc/${PACKAGE_TARNAME}
dvidir = ${docdir}
enable_bytes = 
enable_dynlink = yes
enable_ocaml = yes
enable_opt = yes
enable_parmap = yes
enable_pcre = yes
enable_pcre_syntax = 
enable_pyml = yes
enable_python = yes
enable_stdcompat = yes
exec_prefix = ${prefix}
host_alias = 
htmldir = ${docdir}
includedir = ${prefix}/include
infodir = ${datarootdir}/info
install_sh = ${SHELL} /home/fantasio/work/coccinelle/setup/install-sh
intnat = 
libdir = ${exec_prefix}/lib
libexecdir = ${exec_prefix}/libexec
localedir = ${datarootdir}/locale
localstatedir = ${prefix}/var
mandir = ${datarootdir}/man
mkdir_p = $(MKDIR_P)
noalloc = 
oldincludedir = /usr/include

=== bundles/menhirLib/Makefile ===
# Bundles the original menhirLib package without modifications.
# This Makefile integrates its build process with coccinelle.

MENHIR_VERSION=20181113

PACKAGE_DIR=menhir-$(MENHIR_VERSION)
MENHIR_MODULES= \
	Fix IO installation keyword lineCount positions stringSet version \
	settings printer codeBits action mark stringMap menhirLib error misc codeBits gSet \
	compressedBitSet option dot InputFile parameters InputFile lexpointfree parserAux \
	parser lexer \
	tarjan unionFind expandTokenAliases partialGrammar time \
	unparameterizedSyntax tokenType nonterminalType interface lexdep \
	lexmli infer listMonad chopInlined sequence CompletedNatWitness \
	Unifier Memoize SortUnification SortInference GroundSort SelectiveExpansion syntax Drop CheckSafeParameterizedGrammar \
	nonTerminalDefinitionInlining reachability unparameterizedPrinter \
	FixSolver Boolean Maps patricia grammarFunctor keywordExpansion \
	anonymous Driver front gMap grammar codePieces item derivation \
	lr0 slr lr1 DependencyGraph lr1partial conflict invariant default Trie MySet resizableArray LowIntegerPriorityQueue LRijkstraCore \
	codeBackend coqBackend \
	pprint cst traverse inliner referenceInterpreter sentenceParser \
	sentenceLexer segment sentenceParserAux interpret tableBackend \
	astar LRijkstra cmly_api \
	cmly_format cmly_read cmly_write back menhir
MERE_INTERFACES=stretch IL lookahead
PRODUCTS=chopInlined lexer lexdep lexmli parser sentenceLexer sentenceParser lexpointfree lineCount segment
SIDEPRODUCTS=menhir menhirLib.cmi
SIDEPRODUCTS_BYTECODE=menhirLib.cmo
SIDEPRODUCTS_NATIVE=menhirLib.cmx menhirLib.o
OTHERS=standard.mly
SRC_DIR := $(PACKAGE_DIR)/src
GENERATED_SOURCE_FILES := $(SRC_DIR)/installation.ml
CLEANOTHERS := menhirLib.ml menhirLib.mli syntax.cmi $(SRC_DIR)/parser.mly $(SRC_DIR)/menhir $(SRC_DIR)/installation.ml

OCAMLLDFLAGS=unix.cmxa
OCAMLFLAGS+=-I $(STDCOMPATDIR)

MENHIRLIB_MODULES= \
	General IncrementalEngine InfiniteArray PackedIntArray LinearizedArray RowDisplacement \
	EngineTypes Engine TableFormat TableInterpreter Convert
MODULES=$(MENHIR_MODULES) $(MENHIRLIB_MODULES)

OCAML_BUNDLES_FLAGS=$(shell \
	if echo $(MENHIRLIB_MODULES) \
		| grep -w $(notdir $(basename $<)) >/dev/null; then \
		echo -for-pack MenhirLib; \
	fi)

include ../Makefile.bundles

include ../../Makefile.package

depend: .depend

.PHONY: distclean
distclean: clean

$(SRC_DIR)/installation.ml:
	echo "let libdir = \"$(shell pwd\)\"" > $(SRC_DIR)/installation.ml
	echo "let ocamlfind = false" >> $(SRC_DIR)/installation.ml

.depend: $(SRC_DIR)/parser.mly

$(SRC_DIR)/Driver.ml: $(SRC_DIR)/yaccDriver.ml
	cp $< $@

ifeq ($(OCAMLOPT_CMD),)
$(SRC_DIR)/menhir: $(patsubst %,$(SRC_DIR)/%.cmo,$(MENHIR_MODULES))
	$(OCAMLC_CMD) $(OCAMLLDFLAGS) $(LINK_BYTECODE) stdcompat.cma $^ -o $@
else
$(SRC_DIR)/menhir: $(patsubst %,$(SRC_DIR)/%.cmx,$(MENHIR_MODULES))
	$(OCAMLOPT_CMD) $(OCAMLLDFLAGS) $(LINK_NATIVE) stdcompat.cmxa $^ -o $@
endif

standard.mly: $(SRC_DIR)/standard.mly
	cp $< $@

$(SRC_DIR)/misc.cmo: $(SRC_DIR)/menhirLib.cmi

$(SRC_DIR)/misc.cmx: $(SRC_DIR)/menhirLib.cmx

$(SRC_DIR)/menhirLib.cmo: \
	$(patsubst %,$(SRC_DIR)/%.cmo,$(MENHIRLIB_MODULES))
	$(OCAMLC_CMD) -pack \
		$(patsubst %,$(SRC_DIR)/%.cmo,$(MENHIRLIB_MODULES)) \
		-o $(SRC_DIR)/menhirLib.cmo
$(SRC_DIR)/menhirLib.cmi: $(SRC_DIR)/menhirLib.cmo

$(SRC_DIR)/menhirLib.cmx: \
	$(patsubst %,$(SRC_DIR)/%.cmx,$(MENHIRLIB_MODULES))
	$(OCAMLOPT_CMD) -pack \
		$(patsubst %,$(SRC_DIR)/%.cmx,$(MENHIRLIB_MODULES)) \
		-o $(SRC_DIR)/menhirLib.cmx
$(SRC_DIR)/menhirLib.o: $(SRC_DIR)/menhirLib.cmx

$(SRC_DIR)/parser.mly: $(SRC_DIR)/yacc-parser.mly
	cp $< $@

$(SRC_DIR)/Driver.cmo $(SRC_DIR)/Driver.cmx: $(SRC_DIR)/Driver.cmi

$(SRC_DIR)/astar.cmo $(SRC_DIR)/astar.cmx: $(SRC_DIR)/menhirLib.cmi

=== bundles/parmap/Makefile ===
# This Makefile serves as a wrapper to bundle the
# parmap package without modifications.

PACKAGE_DIR=parmap
MODULES=bytearray parmap_utils setcore parmap
OBJS=$(MODULES)
INTERFACES=$(OBJS)
C_OBJS=bytearray setcore
ARCHIVE=parmap
LIBRARY=parmap
SRC_DIR=$(PACKAGE_DIR)

OCAMLCCFLAGS+=-ccopt -D_GNU_SOURCE

include ../Makefile.bundles

parmap/bytearray.cmo : parmap/bytearray.cmi

.prepare:
	cd $(SRC_DIR) && ./configure
	touch $@

.PHONY: distclean
distclean: clean

=== bundles/pcre/Makefile ===
# This Makefile serves as a wrapper to bundle the
# pcre module without modifications.

MODULES=pcre
OBJS=pcre
INTERFACES=pcre
C_OBJS=pcre
ARCHIVE=pcre
LIBRARY=pcre
C_LIBS=pcre
SRC_DIR=pcre-ocaml/src

OCAMLFLAGS+=-I $(STDCOMPATDIR)

EXTRACFLAGS=$(PCRE_CFLAGS:%=-ccopt %) $(PCRE_LIBS:%=-cclib %)
EXTRALNKFLAGS=$(PCRE_LIBS:%=-ldopt %)

include ../Makefile.bundles

.PHONY: distclean
distclean:

=== bundles/pyml/Makefile ===
# This Makefile serves as a wrapper to bundle the
# pyml module without modifications.

PYML_VERSION=current

PACKAGE_DIR := pyml-$(PYML_VERSION)
TARBALL=
MODULES=pyml_arch pyutils pytypes pywrappers py pycaml
OBJS=$(MODULES)
INTERFACES=pywrappers py pycaml
C_OBJS=pyml
ARCHIVE=pyml
LIBRARY=pyml
SIDEPRODUCTS=
SRC_DIR := $(PACKAGE_DIR)
OTHERS := $(SRC_DIR)/pyml_arch.ml
OCAMLFLAGS+=-I $(STDCOMPATDIR)
CLEANOTHERS=pyml-current/generate pyml-current/generate.cmi \
	pyml-current/generate.cmx pyml-current/generate.cmo \
	pyml-current/generate.cmt pyml-current/generate.cmti \
	pyml-current/generate.o pyml-current/pyml.a \
	pyml-current/pyml.cma pyml-current/pyml.cmxa \
	pyml-current/dllpyml_stubs.so
GENERATED_SOURCE_FILES := $(SRC_DIR)/pywrappers.ml $(SRC_DIR)/pywrappers.mli
OCAMLCCFLAGS+=-ccopt -I$(STDCOMPATDIR)

UNAME_ARCH := $(shell uname)

ifeq ($(UNAME_ARCH),Darwin)
	PYML_ARCH := pyml_arch_darwin.ml
else ifeq ($(findstring CYGWIN,$(UNAME_ARCH)),CYGWIN)
	PYML_ARCH := pyml_arch_cygwin.ml
else
	PYML_ARCH := pyml_arch_unix.ml
endif

include ../Makefile.bundles

ifeq ($(MAKECMDGOALS),all.opt)
	NATIVE := yes
else
	NATIVE := no
endif

include ../../Makefile.package

ifeq ($(NATIVE),yes)
	OCAMLCOPT := $(OCAMLOPT_CMD)
	CMOX := cmx
	CMAX := cmxa
	LINK_BEST := $(LINK_NATIVE)
else
	OCAMLCOPT := $(OCAMLC_CMD)
	CMOX := cmo
	CMAX := cma
	LINK_BEST := $(LINK_BYTECODE)
endif


distclean: clean
	rm -f .prepare

$(SRC_DIR)/pywrappers.ml \
$(SRC_DIR)/pyml_wrappers.inc: \
		$(MARKER) $(SRC_DIR)/generate
	cd $(SRC_DIR) && ./generate

$(SRC_DIR)/pyml_wrappers.inc: $(SRC_DIR)/pywrappers.ml

$(SRC_DIR)/pyml_stubs.o: $(SRC_DIR)/pyml_stubs.c $(SRC_DIR)/pyml_wrappers.inc

$(SRC_DIR)/pyml_arch.mli \
$(SRC_DIR)/$(PYML_ARCH) \
$(SRC_DIR)/generate.ml \
$(SRC_DIR)/pytypes.mli: $(MARKER)

$(SRC_DIR)/pywrappers.mli: \
	$(SRC_DIR)/pywrappers.ml $(SRC_DIR)/pytypes.cmi $(SRC_DIR)/pyml_arch.cmi
	$(OCAMLC_CMD) -i $< >$@

$(SRC_DIR)/pyml_arch.cmx: $(SRC_DIR)/pyml_arch.ml $(SRC_DIR)/pyml_arch.cmi
	$(OCAMLOPT_CMD) -c $< -o $@

$(SRC_DIR)/pyml_arch.cmo: $(SRC_DIR)/pyml_arch.ml $(SRC_DIR)/pyml_arch.cmi
	$(OCAMLC_CMD) -c $< -o $@

$(SRC_DIR)/pyutils.cmo $(SRC_DIR)/pyutils.cmx : $(SRC_DIR)/pyutils.cmi

$(SRC_DIR)/generate : $(SRC_DIR)/pyutils.$(CMOX) $(SRC_DIR)/generate.$(CMOX)
	$(OCAMLCOPT) $(OCAMLLDFLAGS) $(LINK_BEST) stdcompat.$(CMAX) unix.$(CMAX) $^ -o $@

$(SRC_DIR)/generate.cmx: $(SRC_DIR)/generate.ml
	$(OCAMLOPT_CMD) -c $< -o $@

$(SRC_DIR)/generate.cmo: $(SRC_DIR)/generate.ml
	$(OCAMLC_CMD) -c $< -o $@

$(SRC_DIR)/pyml_arch.ml: $(SRC_DIR)/$(PYML_ARCH)
	cp $< $@

=== bundles/stdcompat/Makefile ===
.PHONY : all
all :
	cd stdcompat-current; $(MAKE) && cp *.mli *.cmi *.cmx *.cma *.cmxa *.a *.h ..

.PHONY : clean
clean :
	rm -f *.mli *.cmi *.cmo *.cmt *.cmti *.cmx *.cma *.cmxa *.a
	cd stdcompat-current && \
		rm -f *.cmi *.cmo *.cmx *.cmt *.cmti *.cma *.cmxa *.a *.cmxs

.PHONY : distclean
distclean : clean

=== bundles/pyml/pyml-current/Makefile ===
PREFIX := /usr/local
OCAMLFIND := ocamlfind
INSTALL := install
INSTALL_PROGRAM := $(INSTALL)
bindir := $(PREFIX)/bin

HAVE_OCAMLFIND := $(shell \
	if $(OCAMLFIND) query -help >/dev/null 2>&1; then \
		echo yes; \
	else \
		echo no; \
	fi \
)

HAVE_UTOP := $(shell \
	if [ "$(HAVE_OCAMLFIND)" = no ]; then \
		echo no; \
	elif $(OCAMLFIND) query utop >/dev/null 2>&1; then \
		echo yes; \
	else \
		echo no; \
	fi \
)

ifneq ($(MAKECMDGOALS),clean)
ifneq ($(HAVE_OCAMLFIND),no)
	OCAMLC := $(OCAMLFIND) ocamlc
	ifneq ($(HAVE_OCAMLOPT),no)
		OCAMLOPTEXE := $(OCAMLFIND) ocamlopt
	endif
	OCAMLMKLIB := $(OCAMLFIND) ocamlmklib
	OCAMLMKTOP := $(OCAMLFIND) ocamlmktop
	OCAMLDEP := $(OCAMLFIND) ocamldep
	OCAMLDOC := $(OCAMLFIND) ocamldoc
	STDCOMPAT := $(shell $(OCAMLFIND) query stdcompat)
        OCAMLCFLAGS := -package stdcompat
        OCAMLLDFLAGS := -linkpkg
	OCAMLBYTECODELIBS := -package unix,stdcompat
	OCAMLBYTECODELIBSNUMPY := -package unix,stdcompat,bigarray
	OCAMLNATIVELIBS := -package unix,stdcompat
	OCAMLNATIVELIBSNUMPY := -package unix,stdcompat,bigarray
else
	OCAMLC := $(shell \
		if ocamlc.opt -version >/dev/null 2>&1; then \
			echo ocamlc.opt; \
		elif ocamlc -version >/dev/null 2>&1; then \
			echo ocamlc; \
		fi \
	)
	ifeq ($(OCAMLC),)
$(error There is no OCaml compiler available in path)
	endif
	ifneq ($(HAVE_OCAMLOPT),no)
		OCAMLOPTEXE := $(shell \
			if ocamlopt.opt -version >/dev/null 2>&1; then \
				echo ocamlopt.opt; \
			elif ocamlopt -version >/dev/null 2>&1; then \
				echo ocamlopt; \
			fi \
		)
	endif
	OCAMLMKLIB := ocamlmklib
	OCAMLMKTOP := ocamlmktop
	OCAMLDEP := ocamldep
	OCAMLDOC := ocamldoc
	STDCOMPAT := .
        OCAMLCFLAGS :=
        OCAMLLDFLAGS :=
	OCAMLBYTECODELIBS := unix.cma stdcompat.cma
	OCAMLBYTECODELIBSNUMPY := unix.cma stdcompat.cma bigarray.cma
	OCAMLNATIVELIBS := unix.cmxa stdcompat.cmxa
	OCAMLNATIVELIBSNUMPY := unix.cmxa stdcompat.cmxa bigarray.cmxa
endif

ifeq ($(wildcard $(STDCOMPAT)/stdcompat.cma),)
$(error stdcompat module not found: please specify the path with STDCOMPAT=...)
endif

OCAMLVERSION := $(shell $(OCAMLC) -version)
endif

ifeq ($(HAVE_UTOP),yes)
	PYMLUTOP := pymlutop
else
	PYMLUTOP :=
endif

ifeq ($(OCAMLOPTEXE),)
	OCAMLOPT = $(error There is no optimizing OCaml compiler available)
	OCAMLCOPT := $(OCAMLC)
	CMOX := cmo
	CMAX := cma
	ALLOPT :=
	TESTOPT :=
	OCAMLPREFERREDLIBS := $(OCAMLBYTECODELIBS)
else
	OCAMLOPT := $(OCAMLOPTEXE)
	OCAMLCOPT := $(OCAMLOPT)
	CMOX := cmx
	CMAX := cmxa
	ALLOPT := all.native
	TESTOPT := test.native
	OCAMLPREFERREDLIBS := $(OCAMLNATIVELIBS)
endif

ifeq (4.06.0,$(word 1,$(sort 4.06.0 $(OCAMLVERSION))))
	PYOPS=pyops
else
	PYOPS=
endif

MODULES := pyml_arch pyutils pytypes pywrappers py pycaml $(PYOPS)

VERSION := $(shell date "+%Y%m%d")

OCAMLLIBFLAGS := -cclib "-L. -lpyml_stubs"
OCAMLLIBNUMPYFLAGS := -cclib "-L. -lnumpy_stubs"

OCAMLLIBFLAGSNATIVE := $(OCAMLLIBFLAGS)
OCAMLLIBFLAGSBYTECODE := -custom $(OCAMLLIBFLAGS)

UNAME_ARCH := $(shell uname)

ifeq ($(UNAME_ARCH),Darwin)
	PYML_ARCH := pyml_arch_darwin.ml
else ifeq ($(findstring CYGWIN,$(UNAME_ARCH)),CYGWIN)
	PYML_ARCH := pyml_arch_cygwin.ml
else
	PYML_ARCH := pyml_arch_unix.ml
endif

INSTALL_FILES := \
	py.mli numpy.mli $(MODULES:=.cmi) $(MODULES:=.cmx) \
	numpy.cmi \
	pyml.cma pyml.cmxa pyml.cmxs pyml.a \
	numpy.cma numpy.cmxa numpy.cmxs numpy.a \
	$(MODULES:=.cmx) numpy.cmx \
	libpyml_stubs.a dllpyml_stubs.so \
	libnumpy_stubs.a dllnumpy_stubs.so \
	META

.PHONY : all
all : all.bytecode $(ALLOPT)
	@echo The py.ml library is compiled.
	@echo Run \`make doc\' to build the documentation.
	@echo Run \`make test\' to check the test suite.
ifneq ($(HAVE_OCAMLFIND),no)
	@echo Run \`make install\' to install the library via ocamlfind.
endif
	@echo Run \`make pymltop\' to build the toplevel.
ifneq ($(HAVE_UTOP),no)
	@echo Run \`make pymlutop\' to build the utop toplevel.
endif

.PHONY : help
help :
	@echo make [all] : build the library
	@echo make all.bytecode : build only the bytecode library
	@echo make all.native : build only the native library
	@echo make doc : build the documentation
ifneq ($(HAVE_OCAMLFIND),no)
	@echo make install : install the library via ocamlfind
endif
	@echo make clean : remove all the generated files
	@echo make tests : compile and run the test suite
	@echo make tests.bytecode : run only the bytecode version of the tests
	@echo make tests.native : run only the native version of the tests
	@echo make pymltop: build the toplevel
ifneq ($(HAVE_UTOP),no)
	@echo make pymlutop: build the utop toplevel.
endif
	@echo make HAVE_OCAMLFIND=no : disable ocamlfind
	@echo make HAVE_OCAMLOPT=no : disable ocamlopt
	@echo \
"make OCAMLC|OCAMLOPT|OCAMLMKLIB|OCAMLMKTOP|OCAMLDEP|OCAMLDOC=... :"
	@echo "  set paths to OCaml tools"
	@echo make OCAMLCFLAGS=... : set flags to OCaml compiler for compiling
	@echo make OCAMLLDFLAGS=... : set flags to OCaml compiler for linking
	@echo make OCAMLLIBFLAGS=... :
	@echo "  set flags to OCaml compiler for building the library"
	@echo make STDCOMPAT=... : set path to the stdcompat library

.PHONY : all.bytecode
all.bytecode : pyml.cma numpy.cma

.PHONY : all.native
all.native : pyml.cmxa pyml.cmxs numpy.cmxa numpy.cmxs

.PHONY : test
test : test.bytecode $(TESTOPT)

.PHONY : test.bytecode
test.bytecode : pyml_tests.bytecode numpy_tests.bytecode
	./pyml_tests.bytecode
	./numpy_tests.bytecode

.PHONY : test.native
test.native : pyml_tests.native numpy_tests.native
	./pyml_tests.native
	./numpy_tests.native

.PHONY : install
install : $(INSTALL_FILES)
ifeq ($(HAVE_OCAMLFIND),no)
	$(error ocamlfind is needed for 'make install')
endif
	$(OCAMLFIND) install pyml $(INSTALL_FILES)
	[ ! -f pymltop ] || $(INSTALL_PROGRAM) pymltop $(bindir)/pymltop
	[ ! -f pymlutop ] || $(INSTALL_PROGRAM) pymlutop $(bindir)/pymlutop

.PHONY : uninstall
uninstall :
	$(OCAMLFIND) remove pyml
	- rm $(bindir)/pymltop
	- rm $(bindir)/pymlutop

.PHONY : clean
clean :
	for module in $(MODULES) numpy generate pyml_tests_common pyml_tests \
		numpy_tests; do \
		rm -f $$module.cmi $$module.cmo $$module.cmx $$module.a \
			$$module.o; \
	done
	rm -f pyml.cma pyml.cmxa pyml.cmxs pyml.a
	rm -f numpy.cma numpy.cmxa numpy.cmxs numpy.a
	rm -f pywrappers.mli pywrappers.ml pyml_dlsyms.inc pyml_wrappers.inc
	rm -f pyml.h
	rm -f pyml_stubs.o dllpyml_stubs.so libpyml_stubs.a
	rm -f numpy_stubs.o dllnumpy_stubs.so libnumpy_stubs.a
	rm -f pyml_arch.ml
	rm -f generate pyml_tests.native pyml_tests.bytecode
	rm -f numpy_tests.native numpy_tests.bytecode
	rm -f .depend
	rm -rf doc
	rm -f pymltop pytop.cmo pymlutop pyutop.cmo
	rm -f pymltop_libdir.ml pymltop_libdir.cmo

.PHONY : tarball
tarball :
	git archive --format=tar.gz --prefix=pyml-$(VERSION)/ HEAD \
		>pyml-$(VERSION).tar.gz

doc : py.mli pycaml.mli numpy.mli pywrappers.ml
	mkdir -p $@
	$(OCAMLDOC) $(OCAMLCFLAGS) -html -d $@ $^
	touch $@

.depend : $(MODULES:=.ml) $(MODULES:=.mli) numpy.ml numpy.mli \
	pyml_tests_common.mli pyml_tests_common.ml pyml_tests.ml numpy_tests.ml
	$(OCAMLDEP) $^ >$@

ifneq ($(MAKECMDGOALS),clean)
-include .depend
endif

pyutils.cmo pyutils.cmx : pyutils.cmi

generate : pyutils.$(CMOX) generate.$(CMOX)
	$(OCAMLCOPT) $(OCAMLLDFLAGS) $(OCAMLPREFERREDLIBS) $^ -o $@

generate.cmo : generate.ml

generate.cmx : generate.ml

pywrappers.ml pyml_wrappers.inc : generate
	./generate

pyml_wrappers.inc : pywrappers.ml

pywrappers.mli : pywrappers.ml pytypes.cmi pyml_arch.cmi
	$(OCAMLC) -i $< >$@

pyml_tests.native : py.cmi pyml.cmxa pyml_tests_common.cmx pyml_tests.cmx
	$(OCAMLOPT) $(OCAMLLDFLAGS) $(OCAMLNATIVELIBS) pyml.cmxa \
		pyml_tests_common.cmx pyml_tests.cmx -o $@

pyml_tests.bytecode : py.cmi pyml.cma pyml_tests_common.cmo pyml_tests.cmo
	$(OCAMLC) $(OCAMLLDFLAGS) $(OCAMLBYTECODELIBS) pyml.cma \
		pyml_tests_common.cmo pyml_tests.cmo -o $@

numpy_tests.native : py.cmi pyml.cmxa numpy.cmxa \
		pyml_tests_common.cmx numpy_tests.cmx
	$(OCAMLOPT) $(OCAMLLDFLAGS) $(OCAMLNATIVELIBSNUMPY) \
		pyml.cmxa numpy.cmxa \
		pyml_tests_common.cmx numpy_tests.cmx -o $@

numpy_tests.bytecode : py.cmi pyml.cma numpy.cma \
		pyml_tests_common.cmo numpy_tests.cmo
	$(OCAMLC) $(OCAMLLDFLAGS) $(OCAMLBYTECODELIBSNUMPY) pyml.cma \
		numpy.cma pyml_tests_common.cmo numpy_tests.cmo -o $@

pyml_arch.ml : $(PYML_ARCH)
	cp $< $@

pyml_arch.cmo pyml_arch.cmx : pyml_arch.cmi

%.cmi : %.mli
	$(OCAMLC) $(OCAMLCFLAGS) -c $< -o $@

%.cmo : %.ml
	$(OCAMLC) $(OCAMLCFLAGS) -c $< -o $@

%.cmx : %.ml
	$(OCAMLOPT) $(OCAMLCFLAGS) -c $< -o $@

%.o : %.c
	$(OCAMLC) -package stdcompat -c $< -o $@

pyml_stubs.o : pyml_wrappers.inc

pyml.cma : $(MODULES:=.cmo) libpyml_stubs.a
	$(OCAMLC) $(OCAMLLIBFLAGSBYTECODE) -a -dllib -lpyml_stubs $(MODULES:=.cmo) -o $@

pyml.cmxa : $(MODULES:=.cmx) libpyml_stubs.a
	$(OCAMLOPT) $(OCAMLLIBFLAGSNATIVE) -a $(MODULES:=.cmx) -o $@

pyml.cmxs : $(MODULES:=.cmx) libpyml_stubs.a
	$(OCAMLOPT) $(OCAMLLIBFLAGSNATIVE) -shared $(MODULES:=.cmx) -o $@

lib%.a : %.o
	$(OCAMLMKLIB) -o $(basename $<) $<

numpy.cma : numpy.cmo libnumpy_stubs.a
	$(OCAMLC) $(OCAMLLIBNUMPYFLAGS) -a -dllib -lnumpy_stubs numpy.cmo -o $@

numpy.cmxa : numpy.cmx libnumpy_stubs.a
	$(OCAMLOPT) $(OCAMLLIBNUMPYFLAGS) -a numpy.cmx -o $@

numpy.cmxs : numpy.cmx libnumpy_stubs.a
	$(OCAMLOPT) $(OCAMLLIBNUMPYFLAGS) -shared numpy.cmx -o $@

pytop.cmo : pytop.ml pymltop_libdir.cmi
	$(OCAMLC) -I +compiler-libs -c $<

pymltop_libdir.ml :
	if [ -z "$(PREFIX)" ]; then \
	  echo "let libdir=\"$(PWD)\""; \
	else \
	  echo "let libdir=\"$(PREFIX)/lib/pyml/\""; \
	fi >$@

pymltop : pyml.cma numpy.cma pymltop_libdir.cmo pytop.cmo
	$(OCAMLMKTOP) $(OCAMLLDFLAGS) $(OCAMLLIBNUMPYFLAGS) $(OCAMLBYTECODELIBSNUMPY) $^ -o $@

pyutop.cmo : pyutop.ml
ifeq ($(HAVE_OCAMLFIND),no)
	$(error ocamlfind is needed for utop)
endif
	$(OCAMLC) $(OCAMLCFLAGS) -thread -package utop -c $< -o $@

pymlutop : pyml.cma numpy.cma pymltop_libdir.cmo pytop.cmo pyutop.cmo
ifeq ($(HAVE_OCAMLFIND),no)
	$(error ocamlfind is needed for utop)
endif
#	ocamlmktop raises "Warning 31". See https://github.com/diml/utop/issues/212
#	$(OCAMLMKTOP) -o $@ -thread -linkpkg -package utop -dontlink compiler-libs $^
	ocamlfind ocamlc -thread -linkpkg -linkall -predicates create_toploop \
		-package compiler-libs.toplevel,utop,stdcompat $^ -o $@

=== bundles/menhirLib/menhir-20181113/doc/Makefile ===
.PHONY: all loop clean

export TEXINPUTS=.:

DEPS = $(wildcard *.tex) $(wildcard *.bib) $(wildcard *.sty) $(wildcard *.mly)

all: manual.pdf manual.html

%.pdf: %.tex $(DEPS)
	pdflatex $*
	bibtex $*
	pdflatex $*
	pdflatex $*

manual.html: manual.tex $(DEPS) $(wildcard *.hva)
	hevea -fix manual.tex
#
# Hevea interprets 'tabbing' environment in a way
# that creates spacing errors in the rendered output
# of "textual version of derivation trees": it
# asks for (padding:0px;) while the TeX rendering
# inserts spacing between columns. Change this
# to {padding:1px;}
	sed -i.bak -e "s/cellpadding0/cellpadding1/" manual.html && rm manual.html.bak
#
# Note: hevea generates images manual00{1,2,3}.png for the tikz pictures
# present in the manual.

loop:
	latexmk -pdf -pvc manual

clean:
	rm -f `cat .gitignore`

=== bundles/menhirLib/menhir-20181113/src/Makefile ===
# ----------------------------------------------------------------------------
# Choose a target.

ifndef TARGET
  TARGET := native
endif

# Build .cmxs in case of native compilation.
ifneq ($(TARGET),byte)
MENHIRLIBCMXS := menhirLib.cmxs
endif

# ----------------------------------------------------------------------------
# Ocamlbuild tool and settings.

OCAMLBUILD := ocamlbuild -classic-display -j 0
ifeq ($(TARGET),byte)
  OCAMLBUILD := $(OCAMLBUILD) -byte-plugin
endif

# ----------------------------------------------------------------------------
# For everyday development.
# Typing "make" will perform just stage 1. This is enough to ensure that
# the source code is correct.

.PHONY: everyday
everyday: installation.ml stage1

# ----------------------------------------------------------------------------
# Building Menhir from scratch (a.k.a. bootstrapping).

.PHONY: bootstrap
bootstrap:
	@ $(MAKE) stage1
	@ $(MAKE) stage2
	@ $(MAKE) stage3

# ----------------------------------------------------------------------------
# Stage 1.
# Build Menhir using ocamlyacc.

.PHONY: stage1
stage1:
	@ $(OCAMLBUILD) -build-dir _stage1 \
	    $(MENHIRLIBCMXS) menhir.$(TARGET)

# ----------------------------------------------------------------------------
# Updating the auto-generated comments in parserMessages.messages.
# We use Menhir (from stage 1).

.PHONY: update
update: stage1
	cp parserMessages.messages parserMessages.messages.bak
	_stage1/menhir.$(TARGET) $(BASEFLAGS) --stdlib . \
	  --update-errors parserMessages.messages.bak \
	  fancy-parser.mly \
	  > parserMessages.messages
	rm parserMessages.messages.bak

# ----------------------------------------------------------------------------
# Stripping away the auto-generated comments in parserMessages.messages.

.PHONY: strip
strip:
	sed -e "/^##/d" -i.bak parserMessages.messages
	rm parserMessages.messages.bak

# ----------------------------------------------------------------------------
# Stage 2.
# Build Menhir using Menhir (from stage 1).

# Do not use . to refer to the current directory, because ocamlbuild
# descends into another directory when executing commands.
# Do not use $(shell pwd) either, because this assumes we are running
# on a Unix platform, and can fail on Windows.
# So, use .., which works fine if ocamlbuild has effectively descended
# into a subdirectory.
SRC   := ..

BASEFLAGS := \
  -lg 1 -la 1 -lc 1 \
  --canonical \
  --table \
  --strict \
  --fixed-exception \

FLAGS := \
  $(BASEFLAGS) \
  -v \
  --stdlib $(SRC) \

.PHONY: stage2
stage2:
	@ $(OCAMLBUILD) -build-dir _stage2 -tag fancy_parser \
	    -use-menhir -menhir "$(SRC)/_stage1/menhir.$(TARGET) $(FLAGS)" \
	    $(MENHIRLIBCMXS) menhir.$(TARGET)

# ----------------------------------------------------------------------------
# Stage 3 (optional).
# Re-generate Menhir's parser using Menhir (from stage 2) and check that it
# is identical to the stage 2 parser.

.PHONY: stage3
stage3:
	@ $(OCAMLBUILD) -build-dir _stage3 -tag fancy_parser \
	    -use-menhir -menhir "$(SRC)/_stage2/menhir.$(TARGET) $(FLAGS)" \
	    parser.ml parser.mli
	@ for i in parser.ml parser.mli ; do \
	    if ! diff _stage2/$$i _stage3/$$i 2>&1 >/dev/null ; then \
	      echo "Bootstrap FAILED: $$i did not reach a fixed point."; exit 1 ; \
	    fi ; \
	  done; \
	  echo "Bootstrap successful."

# ----------------------------------------------------------------------------

# The ocamlbuild targets that should be used to build menhirSdk.

MENHIRSDK       := menhirSdk.cmo
ifneq ($(TARGET),byte)
MENHIRSDK       := $(MENHIRSDK) menhirSdk.cmx menhirSdk.cmxs
endif

# ----------------------------------------------------------------------------
# Building menhirSdk.

.PHONY: sdk
sdk:
	@ $(OCAMLBUILD) \
	    -build-dir _sdk \
	    -tag sdk \
	    $(MENHIRSDK)

# ----------------------------------------------------------------------------
# Cleaning up.

.PHONY: clean
clean::
	rm -rf _stage1 _stage2 _stage3 _sdk

=== bundles/pcre/pcre-ocaml/examples/Makefile ===
TARGETS = $(addsuffix .bc, cloc count_hash pcregrep subst)

.PHONY: all clean

all:
	@dune build $(TARGETS)

clean:
	@dune clean

=== bundles/pcre/pcre-ocaml/src/Makefile ===
TARGETS = pcre.cma libpcre_stubs.a

.PHONY: all clean

all:
	@dune build $(TARGETS)

clean:
	@dune clean

=== debian/changelog ===
coccinelle (1.1.0.deb-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Source-only upload.

 -- Adrian Bunk <bunk@debian.org>  Tue, 02 Mar 2021 13:57:22 +0200

coccinelle (1.1.0.deb-1) unstable; urgency=medium

  * d/rules: Force pdflatex to use SOURCE_DATE_EPOCH for \today.
    - Set FORCE_SOURCE_DATE envs.
  * d/watch: update to look into the oficial release
  * New upstream version 1.1.0.deb
  * d/patches: Remove already applied patches.
  * d/control: Update my contact information.
  * d/control: Bump Standards-Version to 4.5.1

 -- Emmanuel Arias <eamanu@yaerobi.com>  Mon, 01 Mar 2021 10:52:30 -0300

coccinelle (1.0.8.deb-5) unstable; urgency=medium

  * Debhelper compatibility level 13
  * Build-depend on libpyml-ocaml-dev (closes: #969451)
  * Filter out the bundle/ directory (which contains vendored ocaml
    libraries) when doing gbp import-orig

 -- Ralf Treinen <treinen@debian.org>  Thu, 03 Sep 2020 04:47:50 +0200

coccinelle (1.0.8.deb-4) unstable; urgency=medium

  * New patch menhir-2200525: solves FTBFS with recent versions of menhir
    (closes: #968946)
  * Compile with python support (closes: #886712)
  * Add myself to Uploaders.

 -- Ralf Treinen <treinen@debian.org>  Wed, 02 Sep 2020 20:45:21 +0200

coccinelle (1.0.8.deb-3) unstable; urgency=medium

  * Team upload
  * Add empty override_dh_dwz to prevent FTBFS
  * Add Rules-Requires-Root: no
  * Depend on ${python3:Depends} instead of ${python:Depends}

 -- Stéphane Glondu <glondu@debian.org>  Sat, 08 Aug 2020 11:07:40 +0200

=== debian/control ===
Source: coccinelle
Section: devel
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Emmanuel Arias <eamanu@yaerobi.com>,
 Ralf Treinen <treinen@debian.org>
Build-Depends: debhelper-compat (=13),
 dh-ocaml (>= 1.0.3~),
 dh-python,
 libmenhir-ocaml-dev (>= 20090204.dfsg),
 libparmap-ocaml-dev (>= 1.0~rc4-5~),
 libpcre-ocaml-dev,
 libstdcompat-ocaml-dev,
 libpyml-ocaml-dev,
 menhir (>= 20090204.dfsg),
 ocaml-findlib,
 ocaml-nox (>= 3.11.1-3~),
 pkg-config (>= 0.9.0),
 python3
Build-Depends-Indep:
 texlive-fonts-extra,
 texlive-fonts-recommended,
 texlive-latex-base,
 texlive-latex-extra,
 texlive-latex-recommended
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: http://coccinelle.lip6.fr
Vcs-Git: https://salsa.debian.org/ocaml-team/coccinelle.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/coccinelle

Package: coccinelle
Architecture: any
Depends: libparmap-ocaml,
         ocaml-findlib,
         ${misc:Depends},
         ${ocaml:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Pre-Depends: dpkg (>= 1.17.14)
Suggests: coccinelle-doc, vim-addon-manager
Description: semantic patching tool for C
 Coccinelle is a program matching and transformation tool for C.
 The programmer describes the code to match and the transformation to
 perform as a semantic patch, which looks like a standard patch, but can
 transform multiple files at any number of code sites.

Package: coccinelle-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: coccinelle (<< 1.0.0~rc7.deb-4)
Replaces: coccinelle (<< 1.0.0~rc7.deb-4)
Description: documentation for coccinelle
 Coccinelle is a program matching and transformation tool for C.
 The programmer describes the code to match and the transformation to
 perform as a semantic patch, which looks like a standard patch, but can
 transform multiple files at any number of code sites.
 .
 This package contains examples files and additional documentation in
 PDF format.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/ocaml/ocamlvars.mk

VIM_ADIR = $(CURDIR)/debian/coccinelle/usr/share/vim/addons
VIM_RDIR = $(CURDIR)/debian/coccinelle/usr/share/vim/registry

CONFIG_FLAGS = --prefix=/usr --sysconfdir=/etc --libdir=/usr/lib \
  --enable-ocaml --enable-python

ifeq ($(OCAML_NATDYNLINK),yes)
CONFIG_FLAGS += --enable-opt
else
CONFIG_FLAGS += --disable-opt
endif

# Force pdflatex to use SOURCE_DATE_EPOCH for \today
export FORCE_SOURCE_DATE = 1

%:
	dh $@ --with ocaml,python3,autoreconf

override_dh_auto_configure:
	./configure $(CONFIG_FLAGS)

override_dh_auto_build-indep:
	$(MAKE) -C docs/manual pdf

override_dh_auto_test-arch:
	$(MAKE) check || echo "IGNORING FAILED TESTS"

override_dh_auto_test-indep:
	# nothing

override_dh_auto_install-arch:
	$(MAKE) DESTDIR=$(CURDIR)/debian/coccinelle install install-bash

	# Vim files
	install -d $(VIM_ADIR)/ftdetect $(VIM_ADIR)/syntax
	cp $(CURDIR)/editors/vim/ftdetect/cocci.vim $(VIM_ADIR)/ftdetect/
	cp $(CURDIR)/editors/vim/syntax/cocci.vim $(VIM_ADIR)/syntax/
	install -d $(VIM_RDIR)
	cp $(CURDIR)/debian/coccinelle.yaml $(VIM_RDIR)/

	# Emacs files
	cp $(CURDIR)/editors/emacs/cocci.el $(CURDIR)/debian/coccinelle/usr/share/emacs/site-lisp/

override_dh_auto_install-indep:
	# Nothing

override_dh_compress:
	dh_compress -X.pdf -X.cocci -X.c

override_dh_dwz:

=== debian/watch ===
version=4
opts=uversionmangle=s/(.*)/$1\.deb/ \
   https://coccinelle.gitlabpages.inria.fr/website/download.html distrib/coccinelle-(.+)\.tar\.gz
